#! /bin/sh
#----------------------------------------------------------------------------
# /var/install/bin/havp-edit-whitelist.sh - edit havp whitlist
#
# Copyright (c) 2010 Olaf Jaehrling <eisfair@ojaehrling.de>
#
# Creation:     26.08.2010 OJae
# Last Update:  26.08.2010 OJae
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#----------------------------------------------------------------------------
. /var/install/include/eislib
. /etc/config.d/havp
. /etc/config.d/setup
configfile=$HAVP_WHITELIST
package='havp'
clrhome
echo
create_editor ()
{
if [ "$EDITOR" = "/var/install/bin/edit-conf.cui" ]
    then
        editor=$EDITOR_FALLBACK
elif [ "$editor" = "joe" ]
    then
        mecho "You can get help by joe if you press 'Ctrl-K H'."
        mecho
elif [ "$editor" = "vi" -o "$editor" = "vim" ]
    then
        mecho "You can get help by vi/vim if you enter ':help'."
        mecho
elif [ "$editor" = ""  ]
    then
        mecho "There is no configuration editor for the EIS/FAIR console configured"
        mecho "on your system. "
        mecho "Please run setup -> System administration -> Base configuration -> Set eisfair configuration editor."
        mecho
        anykey
        exit 1
fi

clrhome
}

create_editor
if [ -f "$configfile" ]
then

    # edit parameter file
        $editor $configfile
        echo
        if /var/install/bin/ask "Activate $package configuration now"
        then
            /etc/init.d/havp restart 
        fi
else
    colecho "Configuration $configfile could not be found!" rd
    /var/install/bin/anykey
fi
