#!/bin/bash
. /etc/config.d/havp
. /var/install/include/check-eisfair-version
. /var/install/include/eislib
. /var/install/include/configlib



if [ "$START_HAVP" = "yes" ]
then
    if [ "$HAVP_ENABLECLAMLIB" = "yes" ]
    then
        if [ ! -f /var/install/packages/clamav ]
        then
            mecho -error "you must install clamav packages!"
            mecho -info "Please enter anykey"
            anykey
            /var/install/bin/packeis-search clamav
        fi
    fi

    if ! grep -wq $HAVP_GROUP /etc/group
    then
        /var/install/bin/add-group havp 86
    fi

    if ! grep -qw $HAVP_USER /etc/passwd
    then
        /var/install/bin/add-user $HAVP_USER '*' 86 86 "HAVP deamon" /usr/local/havp /bin/bash
    fi

    FOLDER=`echo $HAVP_SCANTEMPFILE| awk -F"/" {'print "/"$2"/"$3'}`
    mkdir -p $FOLDER
    chown $HAVP_USER $FOLDER
    ln -sf /etc/init.d/havp /etc/rc2.d/S60havp
    ln -sf /etc/init.d/havp /etc/rc2.d/K49havp
    
    #### pruefen ob der havp-port geaendert wurde
    if [ -f /usr/local/havp/etc/havp.conf ]
    then
        havp_old_port=`grep -w PORT /usr/local/havp/etc/havp.conf | grep -v '#' | awk {'print $2'}`
        if [ "$havp_old_port" != "$HAVP_PORT" ]
        then
            echo "HAVP_OLD_PORT="$havp_old_port >/tmp/havp_old_port
        fi
    fi
    if [ "$HAVP_USE_SQUID" = "yes" ]
    then
        if [ ! -f /var/install/packages/squid ]
        then
            mecho -error "you must install squid packages!"
            mecho -info "Please enter anykey"
            anykey
            /var/install/bin/packeis-search squid
        fi
        #### havp in squidinit hinzufuegen
        if [ -f /var/install/packages/squid ]
        then
            if ! grep -qw havp /etc/init.d/squid
            then
                ANFANG=`grep -n 'stop)' /etc/init.d/squid | awk {'print $1'} | sed s"/://"`
                GESAMMT=`wc -l </etc/init.d/squid`
                HEAD=`echo "$ANFANG -14" | bc -l`
                FOOT=`echo "$GESAMMT - $ANFANG +14" | bc -l`
                head -n$HEAD /etc/init.d/squid >/tmp/squidinit
                (
                echo '                      if [ -f /var/install/packages/havp ]'
                echo '                      then'
                echo '                          /etc/init.d/havp restart havp'
                echo '                      fi'
                ) >>/tmp/squidinit
                tail -$FOOT /etc/init.d/squid >>/tmp/squidinit
                mv /tmp/squidinit /etc/init.d/squid
                chmod 0700 /etc/init.d/squid
            fi
        fi

    fi
    if [ "$HAVP_USE_SQUID" = "yes" -a "$HAVP_USE_STANDALONE" = "yes" ]
    then
        mecho -error "You must decide between HAVP_USE_SQUID or HAVP_USE_STANDALONE!"
        mecho -error "Please go back to the edit mode and activate START_HAVP"
        mecho -error "and select HAVP_USE_SQUID or HAVP_USE_STANDALONE."
        anykey
        sed -i "/^START_HAVP=/s/=.*/='no'/" /etc/config.d/havp
        exit 1
    fi
    if [ "$HAVP_USE_SQUID" = "no" -a "$HAVP_USE_STANDALONE" = "no" ]
    then
        mecho -error "You must decide between HAVP_USE_SQUID or HAVP_USE_STANDALONE!"
        mecho -error "Please go back to the edit mode and activate START_HAVP"
        mecho -error "and select HAVP_USE_SQUID or HAVP_USE_STANDALONE."
        anykey
        sed -i "/^START_HAVP=/s/=.*/='no'/" /etc/config.d/havp
        exit 1
    fi

    if [ "$HAVP_ENABLEFPROT" = "yes" ]
    then
        if [ ! -f /usr/local/f-prot/fpscan ]
        then
            mecho -error "you must install fprot !"
            mecho -error "exiting"
            exit 1
        fi
    fi


    (
    echo "#"
    echo "# This is the configuration file for HAVP"
    echo "#"
    echo "# All lines starting with a hash (#) or empty lines are ignored."
    echo "# Uncomment parameters you want to change!"
    echo "#"
    echo "# All parameters configurable in this file are explained and their default"
    echo "# values are shown. If no default value is defined "NONE" is specified."
    echo "#"
    echo "# General syntax: Parameter Value"
    echo "# Value can be: true/false, number, or path"
    echo "#"
    echo "# Extra spaces and tabs are ignored."
    echo "#"
    echo ""
    echo "# You must remove this line for HAVP to start."
    echo "# This makes sure you have (hopefully) reviewed the configuration. :)"
    echo "# Hint: You must enable some scanner! Find them in the end.."
    echo "# REMOVETHISLINE deleteme"
    echo ""
    echo "#"
    echo "# For reasons of security it is recommended to run a proxy program"
    echo "# without root rights. It is recommended to create user that is not"
    echo "# used by any other program."
    echo "#"
    echo "# Default:"
    echo "# USER havp"
    echo "# GROUP havp"
    echo "USER "$HAVP_USER
    echo "GROUP "$HAVP_GROUP
    echo ""
    echo "# If this is true HAVP is running as daemon in background."
    echo "# For testing you may run HAVP at your text console."
    echo "#"
    echo "# Default:"
    echo "DAEMON true"
    echo ""
    echo "#"
    echo "# Process id (PID) of the main HAVP process is written to this file."
    echo "# Be sure that it is writeable by the user under which HAVP is running."
    echo "# /etc/init.d/havp script requires this to work."
    echo "#"
    echo "# Default:"
    echo "# PIDFILE /var/lib/run/havp/havp.pid"
    echo "PIDFILE /run/havp_daemon.pid"
    echo "#"
    echo "# For performance reasons several instances of HAVP have to run."
    echo "# Specify how many servers (child processes) are simultaneously"
    echo "# listening on port PORT for a connection. Minimum value should be"
    echo "# the peak requests-per-second expected + 5 for headroom. For best"
    echo "# performance, you should have atleast 1 CPU core per 16 processes."
    echo "#"
    echo "# For single user home use, 8 should be minimum."
    echo "# For 500+ users corporate use, start at 40."
    echo "#"
    echo "# Value can and should be higher than recommended. Memory and"
    echo "# CPU usage is only affected by the number of concurrent requests."
    echo "#"
    echo "# More childs are automatically created when needed, up to MAXSERVERS."
    echo "#"
    echo "# Default:"
    echo "# SERVERNUMBER 8"
    echo "# MAXSERVERS 100"
    echo "SERVERNUMBER "$HAVP_SERVERNUMBER
    echo "MAXSERVERS "$HAVP_MAXSERVERS
    echo "#"
    echo "# Files where to log requests and info/errors."
    echo "# Needs to have write permission for HAVP user."
    echo "#"
    echo "# Default:"
    echo "# ACCESSLOG /var/lib/log/havp/access.log"
    echo "# ERRORLOG /var/lib/log/havp/havp.log"
    echo "# VIRUSLOG (same as ACCESSLOG)"
    echo "ACCESSLOG /var/log/havp/access.log"
    echo "ERRORLOG /var/log/havp/error.log"
    echo "#"
    echo "# Format for timestamps in logfile messages."
    echo "# See: man strftime"
    echo "#"
    echo "# Default:"
    echo "# TIMEFORMAT %d/%m/%Y %H:%M:%S"
    echo ""
    echo "#"
    echo "# Syslog can be used instead of logging to file."
    echo "# For facilities and levels, see "man syslog"."
    echo "#"
    echo "# Default:"
    echo "# USESYSLOG false"
    echo "# SYSLOGNAME havp"
    echo "# SYSLOGFACILITY daemon"
    echo "# SYSLOGLEVEL info"
    echo "# SYSLOGVIRUSLEVEL warning"
    echo ""
    echo "#"
    echo "# true: Log every request to access log"
    echo "# false: Log only viruses to access log"
    echo "#"
    echo "# Default:"
    echo "LOG_OKS true"
    echo ""
    echo "#"
    echo "# Level of HAVP logging"
    echo "#  0 = Only serious errors and information"
    echo "#  1 = Less interesting information is included"
    echo "#"
    echo "# Default:"
    echo "# LOGLEVEL 0"
    echo ""
    echo "#"
    echo "# Temporary scan file."
    echo "# This file must reside on a partition for which mandatory"
    echo "# locking is enabled. For Linux, use "-o mand" in mount command."
    echo "# See "man mount" for details. Solaris does not need any special"
    echo "# steps, it works directly."
    echo "#"
    echo "# Specify absolute path to a file which name must contain "XXXXXX"."
    echo "# These characters are used by system to create unique named files."
    echo "#"
    echo "# Default:"
    echo "# SCANTEMPFILE /var/tmp/havp/havp-XXXXXX"
    echo "SCANTEMPFILE "$HAVP_SCANTEMPFILE
    echo "#"
    echo "# Directory for ClamAV and other scanner created tempfiles."
    echo "# Needs to be writable by HAVP user. Use ramdisk for best performance."
    echo "#"
    echo "# Default:"
    echo "# TEMPDIR /var/tmp"
    echo "TEMPDIR" $HAVP_TEMPDIR
    echo "#"
    echo "# HAVP reloads scanners virus database by receiving a signal"
    echo "# (send SIGHUP to PID from PIDFILE, see "man kill") or after"
    echo "# a specified period of time. Specify here the number of"
    echo "# minutes to wait for reloading."
    echo "#"
    echo "# This only affects library scanners (clamlib, trophie)."
    echo "# Other scanners must be updated manually."
    echo "#"
    echo "# Default:"
    echo "# DBRELOAD 60"
    echo ""
    echo "#"
    echo "# Run HAVP as transparent Proxy?"
    echo "#"
    echo "# If you don't know what this means read the mini-howto"
    echo "# TransparentProxy written by Daniel Kiracofe."
    echo "# (e.g.: http://www.tldp.org/HOWTO/mini/TransparentProxy.html)"
    echo "# Definitely you have more to do than setting this to true."
    echo "# You are warned!"
    echo "#"
    echo "# Default:"
    echo "# TRANSPARENT false"
    if [ "$HAVP_TRANSPARENT" = "no" ]
    then
        echo "TRANSPARENT false"
    else
        echo "TRANSPARENT true"
    fi
    echo ""
    echo "#"
    echo "# Specify a parent proxy (e.g. Squid) HAVP should use."
    echo "# If needed, user and password authentication can be used,"
    echo "# but only Basic-authentication scheme is supported."
    echo "#"
    echo "# Default: NONE"
    echo "# PARENTPROXY localhost"
    echo "# PARENTPORT 3128"
    echo "# PARENTUSER username"
    echo "# PARENTPASSWORD password"
    echo ""
    echo "#"
    echo "# Write X-Forwarded-For: to log instead of connecters IP?"
    echo "#"
    echo "# If HAVP is used as parent proxy by some other proxy, this allows"
    echo "# to write the real users IP to log, instead of proxy IP."
    echo "#"
    echo "# Default:"
    echo "# FORWARDED_IP false"
    echo ""
    echo "#"
    echo "# Send X-Forwarded-For: header to servers?"
    echo "#"
    echo "# If client sent this header, FORWARDED_IP setting defines the value,"
    echo "# then it is passed on. You might want to keep this disabled for security"
    echo "# reasons. Enable this if you use your own parent proxy after HAVP, so it"
    echo "# will see the original client IP."
    echo "#"
    echo "# Disabling this also disables Via: header generation."
    echo "#"
    echo "# Default:"
    echo "# X_FORWARDED_FOR false"
    echo ""
    echo "#"
    echo "# Port HAVP is listening on."
    echo "#"
    echo "# Default:"
    echo "# PORT 8080"
    echo "PORT "$HAVP_PORT
    echo "#"
    echo "# IP address that HAVP listens on."
    echo "# Let it be undefined to bind all addresses."
    echo "#"
    echo "# Default: NONE"
    echo "# BIND_ADDRESS 127.0.0.1"
    echo ""
    echo "#"
    echo "# IP address used for sending outbound packets."
    echo "# Let it be undefined if you want OS to handle right address."
    echo "#"
    echo "# Default: NONE"
    echo "# SOURCE_ADDRESS 1.2.3.4"
    echo ""
    echo "#"
    echo "# Path to template files."
    echo "#"
    echo "# Default:"
    echo "# TEMPLATEPATH /etc/havp/templates/en"
    echo "TEMPLATEPATH" $HAVP_TEMPLATEPATH
    echo "#"
    echo "# Set to true if you want to prefer Whitelist."
    echo "# If URL is Whitelisted, then Blacklist is ignored."
    echo "# Otherwise Blacklist is preferred."
    echo "#"
    echo "# Default:"
    echo "# WHITELISTFIRST true"
    echo ""
    echo "#"
    echo "# List of URLs not to scan."
    echo "#"
    echo "# Default:"
    echo "# WHITELIST /etc/havp/whitelist"
    echo "WHITELIST " $HAVP_WHITELIST
    echo "#"
    echo "# List of URLs that are denied access."
    echo "#"
    echo "# Default:"
    echo "# BLACKLIST /etc/havp/blacklist"
    echo "BLACKLIST " $HAVP_BLACKLIST
    echo "#"
    echo "# Is scanner error fatal?"
    echo "#"
    echo "# For example, archive types that are not supported by scanner"
    echo "# may return error. Also if scanner has invalid pattern files etc."
    echo "#"
    echo "# true: User gets error page"
    echo "# false: No error is reported (viruses might not be detected)"
    echo "#"
    echo "# Default:"
    echo "# FAILSCANERROR true"
    echo ""
    echo "#"
    echo "# When scanning takes longer than this, it will be aborted."
    echo "# Timer is started after HAVP has fully received all data."
    echo "# If set too low, complex files/archives might produce timeout."
    echo "# Timeout is always a fatal error regardless of FAILSCANERROR."
    echo "#"
    echo "# Time in minutes!"
    echo "#"
    echo "# Default:"
    echo "# SCANNERTIMEOUT 10"
    echo ""
    echo "#"
    echo "# Allow HTTP Range requests?"
    echo "#"
    echo "# false: Broken downloads can NOT be resumed"
    echo "# true: Broken downloads can be resumed"
    echo "#"
    echo "# Allowing Range is a security risk, because partial"
    echo "# HTTP requests may not be properly scanned."
    echo "#"
    echo "# Whitelisted sites are allowed to use Range in any case."
    echo "#"
    echo "# Default:"
    echo "# RANGE false"
    if [ "$HAVP_ALLOW_RESUME" = "yes" ]
    then
        echo "RANGE true"
    else
        echo "RANGE false"
    fi
    echo ""
    echo "#"
    echo "# Allow HTTP Range request to get the ZIP header first?"
    echo "#"
    echo "# This allows (partial) scanning of ZIP files that are bigger than"
    echo "# MAXSCANSIZE. Scanning is done up to that many bytes into the file."
    echo "#"
    echo "# Default:"
    echo "# PRELOADZIPHEADER true"
    echo ""
    echo "#"
    echo "# If you really need more performance, you can disable scanning of"
    echo "# JPG, GIF and PNG files. These are probably the most common files"
    echo "# around, so it will save lots of CPU. But be warned, image exploits"
    echo "# exist and more could be found. Think twice if you want to disable!"
    echo "#"
    echo "# In addition of checking Content-Type: image/*, this setting uses"
    echo "# file magic to make sure the file is really image."
    echo "#"
    echo "# Also see SCANMIME/SKIPMIME settings to control scanning based"
    echo "# on just the Content-Type header."
    echo "#"
    echo "# Default:"
    echo "# SCANIMAGES true"
    echo ""
    echo "#"
    echo "# What MIME types NOT to scan. For performance reasons, you could"
    echo "# exclude all media types."
    echo "#"
    echo "# Based on Content-Type: header as given by the HTTP server."
    echo "# Note that it is easy to forge and should not be trusted."
    echo "#"
    echo "# Basic wildcard match supported."
    echo "#"
    echo "# Default: NONE"
    echo "# SKIPMIME image/* video/* audio/*"
    echo ""
    echo "#"
    echo "# If set, then ONLY these MIME types will be scanned."
    echo "#"
    echo "# Based on Content-Type: header as given by the HTTP server."
    echo "# Note that it is easy to forge and should not be trusted."
    echo "#"
    echo "# Basic wildcard match supported."
    echo "#"
    echo "# Default: NONE"
    echo "# SCANMIME application/*"
    echo ""
    echo "#"
    echo "# Temporary file will grow only up to this size. This means scanner"
    echo "# will scan data until this limit is reached."
    echo "#"
    echo "# There are two sides to this setting. By limiting the size, you gain"
    echo "# performance, less waiting for big files and less needed temporary space."
    echo "# But there is slightly higher chance of virus slipping through (though"
    echo "# scanning large archives should not be gateways function, HAVP is more"
    echo "# geared towards small exploit detection etc)."
    echo "#"
    echo "# VALUE IN BYTES NOT KB OR MB!!!!"
    echo "#  0 = No size limit"
    echo "#"
    echo "# Default:"
    echo "# MAXSCANSIZE 5000000"
    echo "MAXSCANSIZE "$HAVP_MAXSCANSIZE
    echo "#"
    echo "# Amount of data going to browser that is held back, until it"
    echo "# is scanned. When we know file is clean, this held back data"
    echo "# can be sent to browser. You can safely set bigger value, only"
    echo "# thing you will notice is some "delay" in beginning of download."
    echo "# Virus found in files bigger than this might not produce HAVP"
    echo "# error page, but result in a "broken" download."
    echo "#"
    echo "# VALUE IN BYTES NOT KB OR MB!!!!"
    echo "#"
    echo "# Default:"
    echo "# KEEPBACKBUFFER 200000"
    echo "KEEPBACKBUFFER "$HAVP_KEEPBACKBUFFER
    echo "#"
    echo "# This setting complements KEEPBACKBUFFER. It tells how many Seconds to"
    echo "# initially receive data from server, before sending anything to client."
    echo "# Even trickling is not done before this time elapses. This way files that"
    echo "# are received fast are more secure and user can get virus report page for"
    echo "# files bigger than KEEPBACKBUFFER."
    echo "#"
    echo "# Setting to 0 will disable this, and only KEEPBACKBUFFER is used."
    echo "#"
    echo "# Default:"
    echo "# KEEPBACKTIME 5"
    echo ""
    echo "#"
    echo "# After Trickling Time (seconds), some bytes are sent to browser"
    echo "# to keep the connection alive. Trickling is not needed if timeouts"
    echo "# are not expected for files smaller than KEEPBACKBUFFER, but it is"
    echo "# recommended to set anyway."
    echo "#"
    echo "# 0 = No Trickling"
    echo "#"
    echo "# Default:"
    echo "# TRICKLING 30"
    echo "TRICKLING" $HAVP_TRICKLING
    echo "#"
    echo "# Send this many bytes to browser every TRICKLING seconds, see above"
    echo "#"
    echo "# Default:"
    echo "# TRICKLINGBYTES 1"
    echo ""
    echo "#"
    echo "# Downloads larger than MAXDOWNLOADSIZE will be blocked."
    echo "# Only if not Whitelisted!"
    echo "#"
    echo "# VALUE IN BYTES NOT KB OR MB!!!!"
    echo "#  0 = Unlimited Downloads"
    echo "#"
    echo "# Default:"
    echo "# MAXDOWNLOADSIZE 0"
    echo ""
    echo "#"
    echo "# Space separated list of strings to partially match User-Agent: header."
    echo "# These are used for streaming content, so scanning is generally not needed"
    echo "# and tempfiles grow unnecessary. Remember when enabled, that user could"
    echo "# fake header and pass some scanning. HTTP Range requests are allowed for"
    echo "# these, so players can seek content."
    echo "#"
    echo "# You can uncomment here a list of most popular players."
    echo "#"
    echo "# Default: NONE"
    echo "STREAMUSERAGENT Player Winamp iTunes QuickTime Audio RMA/ MAD/ Foobar2000 XMMS"
    echo ""
    echo "#"
    echo "# Bytes to scan from beginning of streams."
    echo "# When set to 0, STREAMUSERAGENT scanning will be completely disabled."
    echo "# It is not recommended as there are some exploits for players."
    echo "#"
    echo "# Default:"
    echo "# STREAMSCANSIZE 20000"
    echo ""
    echo "#"
    echo "# Disable mandatory locking (dynamic scanning) for certain file types."
    echo "# This is intended for fixing cases where a scanner forces use of mmap()"
    echo "# call. Mandatory locking might not allow this, so you could get errors"
    echo "# regarding memory allocation or I/O. You can test the "None" option"
    echo "# anyway, as it might even work depending on your OS (some Linux seems"
    echo "# to allow mand+mmap)."
    echo "#"
    echo "# Allowed values:"
    echo "#   None"
    echo "#   ClamAV:BinHex  (mmap forced in versions older than 0.96)"
    echo "#   ClamAV:PDF     (mmap forced in versions older than 0.96)"
    echo "#   ClamAV:ZIP     (mmap forced in 0.93.x, should work in 0.94)"
    echo "#   AVG:ALL        (AVG 8.5 does not work, uses mmap MAP_SHARED)"
    echo "#"
    echo "# Default:"
    echo "# DISABLELOCKINGFOR AVG:ALL"
    echo ""
    echo "#"
    echo "# Whitelist specific viruses by case-insensitive substring match."
    echo "# For example, "Oversized." and "Encrypted." are good candidates,"
    echo "# if you can't disable those checks any other way."
    echo "#"
    echo "# Default: NONE"
    echo "# IGNOREVIRUS Oversized. Encrypted. Phishing."
    echo ""
    echo ""
    echo "#####"
    echo "##### ClamAV Library Scanner (libclamav)"
    echo "#####"
    echo ""
    if [ "$HAVP_ENABLECLAMLIB" = "yes" ]
    then
        echo "ENABLECLAMLIB true"
        echo "# HAVP uses libclamav hardcoded pattern directory, which usually is"
        echo "# /usr/local/share/clamav. You only need to set CLAMDBDIR, if you are"
        echo "# using non-default DatabaseDirectory setting in clamd.conf."
        echo "#"
        echo "# Default: NONE"
        echo "# CLAMDBDIR /path/to/directory"
        echo "CLAMDBDIR /usr/share/clamav"
        echo ""
        echo "# Should we block broken executables?"
        echo "#"
        echo "# Default:"
        echo "# CLAMBLOCKBROKEN false"
        echo ""
        echo "# Should we block encrypted archives?"
        echo "#"
        echo "# Default:"
        echo "# CLAMBLOCKENCRYPTED false"
        echo ""
        echo "# Should we block files that go over maximum archive limits?"
        echo "#"
        echo "# Default:"
        echo "# CLAMBLOCKMAX false"
        echo ""
        echo "# Scanning limits?"
        echo "# You can find some additional info from documentation or clamd.conf"
        echo "#"
        echo "# Stop when this many total bytes scanned (MB)"
        echo "# CLAMMAXSCANSIZE 20"
        echo "CLAMMAXSCANSIZE "$HAVP_CLAMMAXSCANSIZE
        echo "#"
        echo "# Stop when this many files have been scanned"
        echo "# CLAMMAXFILES 50"
        echo "CLAMMAXFILES "$HAVP_CLAMMAXFILES
        echo "#"
        echo "# Dont scan files over this size (MB)"
        echo "# CLAMMAXFILESIZE 100"
        echo "CLAMMAXFILESIZE "$HAVP_CLAMMAXFILESIZE
        echo "#"
        echo "# Maximum archive recursion"
        echo "# CLAMMAXRECURSION 8"
        echo "CLAMMAXRECURSION "$HAVP_CLAMMAXRECURSION
        echo ""
        echo ""
        echo "#####"
        echo "##### ClamAV Socket Scanner (clamd)"
        echo "#####"
        echo "##### NOTE: ClamAV Library Scanner should be preferred (less overhead)"
        echo "#####"
        echo ""
        echo "ENABLECLAMD false"
        echo ""
        echo "# Path to clamd socket"
        echo "#"
        echo "# Default:"
        echo "# CLAMDSOCKET /tmp/clamd"
        echo "CLAMDSOCKET "$HAVP_CLAMSOCKET
        echo "# ..OR if you use clamd TCP socket, uncomment to enable use"
        echo "#"
        echo "# Clamd daemon needs to run on the same server as HAVP"
        echo "#"
        echo "# Default: NONE"
        echo "# CLAMDSERVER 127.0.0.1"
        echo "# CLAMDPORT 3310"
        echo ""
    else
        echo "ENABLECLAMLIB false"
    fi
    echo ""
    echo "#####"
    echo "##### F-Prot Socket Scanner"
    echo "#####"
    echo ""
    if [ "$HAVP_ENABLEFPROT" = "yes" ]
    then
        echo "ENABLEFPROT true"
        echo "FPROTSERVER "$HAVP_FPROTSERVER
        echo "FPROTPORT "$HAVP_FPROTPORT
        echo "FPROTOPTIONS "$HAVP_FPROTOPTIONS
    else
        echo "ENABLEFPROT false"
        echo ""
        echo "# F-Prot daemon needs to run on same server as HAVP"
        echo "#"
        echo "# Default:"
        echo "# FPROTSERVER 127.0.0.1"
        echo "# FPROTPORT 10200"
        echo ""
        echo "# F-Prot options (only for version 6+ !)"
        echo "#"
        echo "# See "fpscand-client.sh --help" for possible options."
        echo "#"
        echo "# At the moment:"
        echo "#  --scanlevel=<n>  Which scanlevel to use, 0-4 (2)."
        echo "#  --heurlevel=<n>  How aggressive heuristics should be used, 0-4 (2)."
        echo "#  --archive=<n>    Scan inside supported archives n levels deep 1-99 (5)."
        echo "#  --adware         Instructs the daemon to flag adware."
        echo "#  --applications   Instructs the daemon to flag potentially unwanted applications."
        echo "#"
        echo "# Default: NONE"
        echo "# FPROTOPTIONS --scanlevel=2 --heurlevel=2"
        echo ""
    fi
    echo ""
    echo "#####"
    echo "##### AVG Socket Scanner"
    echo "#####"
    echo ""
    echo "ENABLEAVG false"
    echo ""
    echo "# AVG daemon needs to run on the same server as HAVP"
    echo "#"
    echo "# Default:"
    echo "# AVGSERVER 127.0.0.1"
    echo "# AVGPORT 55555"
    echo ""
    echo ""
    echo "#####"
    echo "##### Kaspersky Socket Scanner"
    echo "#####"
    echo ""
    echo "ENABLEAVESERVER false"
    echo ""
    echo "# Path to aveserver socket"
    echo "#"
    echo "# Default:"
    echo "# AVESOCKET /var/run/aveserver"
    echo ""
    echo ""
    echo "#####"
    echo "##### Sophos Scanner (Sophie)"
    echo "#####"
    echo ""
    echo "ENABLESOPHIE false"
    echo ""
    echo "# Path to sophie socket"
    echo "#"
    echo "# Default:"
    echo "# SOPHIESOCKET /var/run/sophie"
    echo ""
    echo ""
    echo "#####"
    echo "##### Trend Micro Library Scanner (Trophie)"
    echo "#####"
    echo ""
    echo "ENABLETROPHIE false"
    echo ""
    echo "# Scanning limits inside archives (filesize = MB):"
    echo "#"
    echo "# Default:"
    echo "# TROPHIEMAXFILES 50"
    echo "# TROPHIEMAXFILESIZE 10"
    echo "# TROPHIEMAXRATIO 250"
    echo ""
    echo ""
    echo "#####"
    echo "##### NOD32 Socket Scanner"
    echo "#####"
    echo ""
    echo "ENABLENOD32 false"
    echo ""
    echo "# Path to nod32d socket"
    echo "#"
    echo "# For 3.0+ version, try /tmp/esets.sock"
    echo "#"
    echo "# Default:"
    echo "# NOD32SOCKET /tmp/nod32d.sock"
    echo ""
    echo "# Used NOD32 Version"
    echo "#"
    echo "#  30 = 3.0+"
    echo "#  25 = 2.5+"
    echo "#  21 = 2.x (very old)"
    echo "#"
    echo "# Default:"
    echo "# NOD32VERSION 25"
    echo ""
    echo ""
    echo "#####"
    echo "##### Avast! Socket Scanner"
    echo "#####"
    echo ""
    echo "ENABLEAVAST false"
    echo ""
    echo "# Path to avastd socket"
    echo "#"
    echo "# Default:"
    echo "# AVASTSOCKET /var/run/avast4/local.sock"
    echo ""
    echo "# ..OR if you use avastd TCP socket, uncomment to enable use"
    echo "#"
    echo "# Avast daemon needs to run on the same server as HAVP"
    echo "#"
    echo "# Default: NONE"
    echo "# AVASTSERVER 127.0.0.1"
    echo "# AVASTPORT 5036"
    echo ""
    echo ""
    echo "#####"
    echo "##### Arcavir Socket Scanner"
    echo "#####"
    echo ""
    echo "ENABLEARCAVIR false"
    echo ""
    echo "# Path to arcavird socket"
    echo "#"
    echo "# For version 2008, default socket is /var/run/arcad.ctl"
    echo "#"
    echo "# Default:"
    echo "# ARCAVIRSOCKET /var/run/arcavird.socket"
    echo ""
    echo "# Used Arcavir version"
    echo "#  2007 = Version 2007 and earlier"
    echo "#  2008 = Version 2008 and later"
    echo "#"
    echo "# Default:"
    echo "# ARCAVIRVERSION 2007"
    echo ""
    echo ""
    echo "#####"
    echo "##### DrWeb Socket Scanner"
    echo "#####"
    echo ""
    echo "ENABLEDRWEB false"
    echo ""
    echo "# Enable heuristic scanning?"
    echo "#"
    echo "# Default:"
    echo "# DRWEBHEURISTIC true"
    echo ""
    echo "# Enable malware detection?"
    echo "# (Adware, Dialer, Joke, Riskware, Hacktool)"
    echo "#"
    echo "# Default:"
    echo "# DRWEBMALWARE true"
    echo ""
    echo "# Path to drwebd socket"
    echo "#"
    echo "# Default:"
    echo "# DRWEBSOCKET /var/drweb/run/.daemon"
    echo ""
    echo "# ..OR if you use drwebd TCP socket, uncomment to enable use"
    echo "#"
    echo "# DrWeb daemon needs to run on the same server as HAVP"
    echo "#"
    echo "# Default: NONE"
    echo "# DRWEBSERVER 127.0.0.1"
    echo "# DRWEBPORT 3000"
    )>/usr/local/havp/etc/havp.conf
    mkdir -p /var/log/havp
    chown $HAVP_USER -R /var/log/havp
    

else
    rm -f /etc/rc2.d/S60havp
    rm -f /etc/rc2.d/K40havp
    /etc/init.d/havp stop
fi
